;the patch in the tool resembles this sort of
;by smkdan

hirom

org 0

SMWSSTART:

db "New Super Mario World Sample Utility 2.0 by smkdan", 0
db "12", 0

!current_bank = $7FBFFF	;currently playing bank

;macros
;======

;relative JSR
macro BSR(dest)
	PER.w ?ReturnAdd-1
	BRL <dest>
?ReturnAdd:
endmacro

;common initial preserve
macro Preserve()
	PEI ($00)	;preserve bytes about to be used to hold the address
	PEI ($02)

	LDY $1DF9	;load SPC bytes 2140 - 2141
	PHY		;preserve
	LDY $1DFB	;load 2142 - 2143
	PHY		;preserve
endmacro

;common restore
macro Restore()
	PLY
	STY $1DFB	;restore 2142 - 2143
	PLY
	STY $1DF9	;restore 2140-2141

	PLY
	STY $02
	PLY
	STY $00
endmacro

;uses 8/16bit Y to index a table using strictly relative access
macro RelativeTableRead(add)
	PHP
	PER.w <add>	;push the location of hack's table onto stack
	LDA ($01,s),y	;no this is not here for the sake of using obscure garbage, PER + this are actually a great combination when using Y
	REP #$10
	PLY
	PLP
endmacro

macro localJSL(dest, rtlop, db)
	PHB			;first save our own DB
	PHK			;first form 24bit return address
	PER.w ?return-1
	PEA.w <rtlop>-1		;second comes 16bit return address
	PEA.w <db><<8|<db>	;change db to desired value
	PLB
	PLB
	JML <dest>
?return:
	PLB			;restore our own DB
endmacro

;reads a byte from this hack relatively
macro RelativeRead(add)
	PHP
	PER.w <add>	;push location of hack's address
	REP #$10
	PLY
	LDA $0000,y
	PLP
endmacro

;spacer tables

TableLevel:
incbin tablelevel.bin	;512 levels
TableOW:
incbin tableow.bin	;7 overworld zones

;DATA ACCESSED BY TOOL
;=====================

db "Jumps"		;quick ID string
	BRL HackLevel
	BRL HackOW
	BRL InitReset
	BRL RESERVED	;future expansion
	BRL RESERVED
	BRL RESERVED
	BRL RESERVED
	BRL RESERVED
	BRL RESERVED
	BRL RESERVED
	BRL RESERVED
DefaultBankByte:
	db $00		;this byte is changed to contain the default bank to upload in place of 0F

RESERVED:
	RTL

;actual hack code
;================

HackLevel:
	PHY		;preserve Y (level num x2)
	PHB
	PHK
	PLB

	SEP #$20	;8bit A
	REP #$10	;16bit XY

	%Preserve()

	LDY $0E				;Y now has level num
	%RelativeTableRead(TableLevel)	;grab bank byte for levels
	CMP !current_bank
	BEQ .return	;if they match, do nothing as it's just not necessary

;new bank to upload right now
	STA !current_bank	;store to currently playing bank

	STA $02		;address setup, bank byte of indirect pointer
	LDA #$80
	STA $01
	LDA #$08	;additional 8 bytes to skip RATS tag
	STA $00

	PHP		;entry condition: must be 8bit AXY
	SEP #$30
	%localJSL($00811D, $804D, $00)	;actually upload this sample bank
	PLP

.return
	%Restore()

;return conditions: Y = restored, A = 0000, 8bit A, 16bit XY
	LDA #$00
	XBA
	LDA #$00	;A = 0000

	PLB
	REP #$10	;16bit PLY
	PLY

	RTL

;-----

HackOW:
	PHP

	PHB
	PHK
	PLB

	REP #$10	;required for preservation
	%Preserve()
	SEP #$10

	LDX $0DB3			;submap depending on who is playing
	LDY $1F11,x
	%RelativeTableRead(TableOW)	;grab bank byte for overworlds
	CMP !current_bank
	BEQ .return	;if they match, do nothing as it's just not necessary

;new bank to upload right now
	STA !current_bank	;store to currently playing bank

	STA $02		;address setup, bank byte of indirect pointer
	LDA #$80
	STA $01
	LDA #$08	;additional 8 bytes to skip RATS tag
	STA $00

	PHP		;entry condition: must be 8bit AXY
	SEP #$30
	%localJSL($00811D, $804D, $00)	;actually upload this sample bank
	PLP

.return
	REP #$10
	%Restore()

;return conditions: X = $0DB3, $0DDA = 00
	STZ $0DDA	;restore routine
	LDX $0DB3

	PLB
	PLP
	RTL

;-----

InitReset:			
	LDA #$00	;simply initialise the currently playing bank to the impossible to reach under normal circumstances value (00)
	STA !current_bank

;return conditions: $2140 = 00, $2141 = 00
	STZ $2140
	STZ $2141

	RTL

;generic shared routines
;-----------------------

;.....



